` 
` Mark Claypool, Phong Le, Makoto Waseda and David Brown
` Worcester Polytechnic Institute, Worcester, MA
` Copyright 2000
`
`

Attribute VB_Name = "HookModule"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"38F10ED0037A"
Option Explicit

'hHook (Handle to the current hook. An application receives
'                 this handle as a result of a previous call to
'                 the SetWindowsHookEx function.)
Public hHook As Long


'ghHook (Handle to the current hook. An application receives
'                 this handle as a result of a previous call to
'                 the SetWindowsHookEx function.)
Public ghHook As Long


'WH_MOUSE Installs a hook procedure that monitors mouse messages.
'         For more information, see the MouseProc hook procedure.
Public Const WH_MOUSE = 7


'WH_KEYBOARD Installs a hook procedure that monitors keystroke
'            messages. For more information, see the KeyboardProc
'            hook procedure.
Public Const WH_KEYBOARD = 2


'The MOUSEHOOKSTRUCT structure contains information about a mouse event passed to
'a WH_MOUSE hook procedure, MouseProc
Dim mhs As MOUSEHOOKSTRUCT


Dim StartMSecForUpArrow As Long 'Stores the number of milliseconds that have elapsed
                                'since the system was started when a user holds down
                                'Up Arrow key
                                
Dim EndMSecForUpArrow As Long   'Stores the number of milliseconds that have elapsed
                                'since the system was started when a user release
                                'Up Arrow key


Dim StartMSecForDownArrow As Long 'Stores the number of milliseconds that have elapsed
                                  'since the system was started when a user holds down
                                  'Down Arrow key

Dim EndMSecForDownArrow As Long 'Stores the number of milliseconds that have elapsed
                                'since the system was started when a user release
                                'Down Arrow key


Dim StartMSecForPageUp As Long 'Stores the number of milliseconds that have elapsed
                               'since the system was started when a user holds down
                               'Page Up key

Dim EndMSecForPageUp As Long  'Stores the number of milliseconds that have elapsed
                              'since the system was started when a user release
                              'Page Up key


Dim StartMSecForPageDown As Long 'Stores the number of milliseconds that have elapsed
                                 'since the system was started when a user holds down
                                 'Page Down key

Dim EndMSecForPageDown As Long 'Stores the number of milliseconds that have elapsed
                               'since the system was started when a user release
                               'Page Down key


'The POINTAPI structure defines the x- and y- coordinates of a point.
'Members: x (Specifies the x-coordinate of the point.)
'         y (Specifies the y-coordinate of the point.)
Public Type POINTAPI
    x As Long
    y As Long
End Type


'The MOUSEHOOKSTRUCT structure contains information about a mouse event passed to
'a WH_MOUSE hook procedure, MouseProc
'Members: pt (Specifies aPOINT structure that contains the x- and y-coordinates of
'             the cursor, in screen coordinates.)
'         hwnd (Handle to the window that will receive the mouse message corresponding
'               to the mouse event.)
'         wHitTestCode (Specifies the hit-test value. For a list of hit-test values,
'                       see the description of theWM_NCHITTEST message.)
'         dwExtraInfo (Specifies extra information associated with the message.)
Public Type MOUSEHOOKSTRUCT
    pt As POINTAPI
    hwnd As Long
    wHitTestCode As Long
    dwExtraInfo As Long
End Type


'The SetWindowsHookEx function installs an application-defined hook procedure into
'a hook chain. You would install a hook procedure to monitor the system for
'certain types of events. These events are associated either with a specific thread
'or with all threads in the system.
'Parameters: idHook (Specifies the type of hook procedure to be installed.
'                    This parameter can be one of the following values:
'                    Value Description)
'                    WH_CALLWNDPROC Installs a hook procedure that monitors messages
'                                   before the system sends them to the destination
'                                   window procedure.For more information, see the
'                                   CallWndProc hook procedure.
'                    WH_CALLWNDPROCRET Installs a hook procedure that monitors messages
'                                      after they have been processed by the destination
'                                      window procedure. For more information, see the
'                                      CallWndRetProc hook procedure.
'                    WH_CBT Installs a hook procedure that receives notifications useful
'                           to a computer-based training (CBT) application. For more
'                           information, see the CBTProc hook procedure.
'                    WH_DEBUG Installs a hook procedure useful for debugging other hook
'                             procedures. For more information, see the DebugProc hook
'                             procedure.
'                    WH_FOREGROUNDIDLE Installs a hook procedure that will be called
'                                      when the application's foreground thread is about
'                                      to become idle. This hook is useful for performing
'                                      low priority tasks during idle time. For more
'                                      information, see the ForegroundIdleProc hook
'                                      procedure.
'                    WH_GETMESSAGE Installs a hook procedure that monitors messages
'                                  posted to a message queue. For more information,
'                                  see the GetMsgProc hook procedure.
'                    WH_JOURNALPLAYBACK Installs a hook procedure that posts messages
'                                       previously recorded by a WH_JOURNALRECORD hook
'                                       procedure. For more information, see the
'                                       JournalPlaybackProc hook procedure.
'                    WH_JOURNALRECORD Installs a hook procedure that records input
'                                     messages posted to the system message queue.
'                                     This hook is useful for recording macros.
'                                     For more information, see the JournalRecordProc
'                                     hook procedure.
'                    WH_KEYBOARD Installs a hook procedure that monitors keystroke
'                                messages. For more information, see the KeyboardProc
'                                hook procedure.
'                    WH_KEYBOARD_LL Windows NT: Installs a hook procedure that monitors
'                                   low-level keyboard input events. For more information,
'                                   see the LowLevelKeyboardProc hook procedure.
'                    WH_MOUSE Installs a hook procedure that monitors mouse messages.
'                             For more information, see the MouseProc hook procedure.
'                    WH_MOUSE_LL Windows NT: Installs a hook procedure that monitors
'                                low-level mouse input events. For more information,
'                                see the LowLevelMouseProc hook procedure.
'                    WH_MSGFILTER Installs a hook procedure that monitors messages
'                                 generated as a result of an input event in a dialog
'                                 box, message box, menu, or scroll bar. For more information,
'                                 see the MessageProc hook procedure.
'                    WH_SHELL Installs a hook procedure that receives notifications
'                             useful to shell applications. For more information,
'                             see the ShellProc hook procedure.
'                    WH_SYSMSGFILTER Installs a hook procedure that monitors messages
'                                    generated as a result of an input event in
'                                    a dialog box, message box, menu, or scroll bar.
'                                    The hook procedure monitors these messages for all
'                                    applications in the system. For more information,
'                                    see the SysMsgProc hook procedure.
'            lpfn (Pointer to the hook procedure. If the dwThreadId parameter is zero
'                  or specifies the identifier of a thread created by a different process,
'                  the lpfn parameter must point to a hook procedure in a dynamic-link
'                  library (DLL). Otherwise, lpfn can point to a hook procedure in
'                  the code associated with the current process.)
'            hmod (Handle to the DLL containing the hook procedure pointed to by
'                  the lpfn parameter. The hMod parameter must be set to NULL if
'                  the dwThreadId parameter specifies a thread created by the current
'                  process and if the hook procedure is within the code associated with
'                  the current process.)
'            dwThreadId (Specifies the identifier of the thread with which the hook
'                        procedure is to be associated. If this parameter is zero,
'                        the hook procedure is associated with all existing threads.)
'Return Values: If the function succeeds, the return value is the handle to
'               the hook procedure.
'               If the function fails, the return value is NULL. To get extended error
'               information, call GetLastError.
Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long


'The CallNextHookEx function passes the hook information to the next hook
'procedure in the current hook chain. A hook procedure can call this function
'either before or after processing the hook information.
'Parameters: ghHook (Handle to the current hook. An application receives
'                 this handle as a result of a previous call to
'                 the SetWindowsHookEx function.)
'            nCode (Specifies the hook code passed to the current hook procedure.
'                   The next hook procedure uses this code to determine
'                   how to process the hook information.)
'            wParam (Specifies the wParam value passed to the current hook
'                    procedure. The meaning of this parameter depends on
'                    the type of hook associated with the current hook chain.)
'            lParam (Specifies the lParam value passed to the current hook
'                    procedure. The meaning of this parameter depends on
'                    the type of hook associated with the current hook chain.)
'Return Values: The return value is the value returned by the next hook
'               procedure in the chain. The current hook procedure must
'               also return this value. The meaning of the return value
'               depends on the hook type. For more information, see
'               the descriptions of the individual hook procedures.
Declare Function CallNextHookEx Lib "user32" (ByVal ghHook As Long, ByVal nCode As Long, ByVal wParam As Integer, ByVal lParam As Long) As Long


'The UnhookWindowsHookEx function removes a hook procedure installed in
'a hook chain by the SetWindowsHookEx function.
'Parameters: ghHook (Handle to the hook to be removed. This parameter is
'                 a hook handle obtained by a previous call to SetWindowsHookEx.
'Return Values: If the function succeeds, the return value is nonzero.
'               If the function fails, the return value is zero.
'               To get extended error information, call GetLastError.
Declare Function UnhookWindowsHookEx Lib "user32" (ByVal ghHook As Long) As Long


'The CopyMemory function copies a block of memory from one location to
'another.
'Parameters: Destination (Pointer to the starting address of the copied
'                         block's destination.)
'            Source (Pointer to the starting address of the block of memory
'                    to copy.)
'            Length (Specifies the size, in bytes, of the block of memory
'                    to copy.)
'Return Values: This function has no return value.
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)


'The MouseProc hook procedure is an application-defined or library-defined callback
'function used with the SetWindowsHookEx function. The system calls this function
'whenever an application calls theGetMessage orPeekMessage function and there is
'a mouse message to be processed.
'Parameters: nCode (Specifies a code the hook procedure uses to determine how to process
'                   the message. This parameter can be one of the following values:)
'                   HC_ACTION The wParam and lParam parameters contain information
'                             about a mouse message.
'                   HC_NOREMOVE The wParam and lParam parameters contain information
'                               about a mouse message, and the mouse message has not
'                               been removed from the message queue. (An application
'                               called the PeekMessage function, specifying
'                               the PM_NOREMOVE flag.)
'                   If nCode is less than zero, the hook procedure must pass
'                   the message to the CallNextHookEx function without further
'                   processing and should return the value returned by CallNextHookEx.
'            wParam (Specifies the identifier of the mouse message.)
'            lParam (Pointer to a MOUSEHOOKSTRUCT structure.)
'Return Values: If nCode is less than zero, the hook procedure must return the value
'               returned by CallNextHookEx.
'               If nCode is greater than or equal to zero, and the hook procedure
'               did not process the message, it is highly recommended that you call
'               CallNextHookEx and return the value it returns; otherwise,
'               other applications that have installed WH_MOUSE hooks will not receive
'               hook notifications and may behave incorrectly as a result. If the hook
'               procedure processed the message, it may return a nonzero value to prevent
'               the system from passing the message to the target window procedure.
Public Function MouseProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    'If nCode is less than zero, the hook procedure must return the value
    'returned by CallNextHookEx.
    If nCode < 0 Then
    ' Forward message and get out
        MouseProc = CallNextHookEx(ghHook, nCode, wParam, lParam)
        Exit Function
    End If

    ' Get MOUSEHOOKSTRUCT pointed to by lParam
    CopyMemory mhs.pt.x, ByVal lParam, LenB(mhs)

    If wParam = 514 And lParam > 0 And Browser.brwWebBrowser.Visible = True And GetActiveWindow() <> 0 Then
        'Holding left mouse button is detected. In addition, browser window is visible (Evaluation
        'Interface is closed) and Curious Browser becomes the active window
        If IsMouseInWindow = 1 Then
            'The mouse cursor is detected inside the browser window
            'Increment the variable
            ClicksOnWindowArray(CurrentNum) = ClicksOnWindowArray(CurrentNum) + 1
            
        ElseIf IsMouseInWindow = 2 Then
            'The mouse cursor is detected inside the Vertical Scroll bar
            'Increment the variable
            EventOnScrollArray(CurrentNum) = EventOnScrollArray(CurrentNum) + 1
            
        ElseIf IsMouseInWindow = 3 Then
            'The mouse cursor is detected inside the Horizontal Scroll bar
            'Increment the variable
            EventOnScrollArray(CurrentNum) = EventOnScrollArray(CurrentNum) + 1
            
        End If
    End If

    ' Forward to next hook
    MouseProc = CallNextHookEx(ghHook, nCode, wParam, lParam)
  
End Function


'The KeyboardProc hook procedure is an application-defined or library-defined callback
'function used with the SetWindowsHookEx function. The system calls this function
'whenever an application calls theGetMessage orPeekMessage function and there is
'a keyboard message (WM_KEYUP orWM_KEYDOWN) to be processed.
'Parameters: nCode (Specifies a code the hook procedure uses to determine how to process
'                  the message. This parameter can be one of the following values:)
'                 HC_ACTION The wParam and lParam parameters contain information about
'                           a keystroke message.
'                 HC_NOREMOVE The wParam and lParam parameters contain information
'                             about a keystroke message, and the keystroke message has
'                             not been removed from the message queue.
'                             (An application called the PeekMessage function,
'                              specifying the PM_NOREMOVE flag.)
'                 If code is less than zero, the hook procedure must pass the message
'                 to the CallNextHookEx function without further processing and
'                 should return the value returned by CallNextHookEx.
'            wParam (Specifies the virtual-key code of the key that generated
'                    the keystroke message.)
'            lParam (Specifies the repeat count, scan code, extended-key flag,
'                    context code, previous key-state flag, and transition-state flag.
'                    This parameter can be a combination of the following values:)
'                    015 Specifies the repeat count. The value is the number of times
'                         the keystroke is repeated as a result of the user's holding
'                         down the key.
'                    1623 Specifies the scan code. The value depends on the original
'                          equipment manufacturer (OEM).
'                    24 Specifies whether the key is an extended key, such as
'                       a function key or a key on the numeric keypad. The value is 1
'                       if the key is an extended key; otherwise, it is 0.
'                    2528 Reserved.
'                    29 Specifies the context code. The value is 1 if the alt key
'                       is down; otherwise, it is 0.
'                    30 Specifies the previous key state. The value is 1 if the key
'                       is down before the message is sent; it is 0 if the key is up.
'                    31 Specifies the transition state. The value is 0 if the key is
'                       being pressed and 1 if it is being released.
Public Function KeyboardProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    'If nCode is less than zero, the hook procedure must return the value
    'returned by CallNextHookEx.
    If nCode < 0 Then
        ' Forward message and get out
        KeyboardProc = CallNextHookEx(hHook, nCode, wParam, lParam)
        Exit Function
    End If
        
        
    If GetActiveWindow() <> 0 Then
        'Curious Browser becomes the active window.
        If wParam = 38 And lParam > 0 Then
            'Up Arrow key is being holded down
            If StartFlagForUpArrow = False Then
                'No Up Arrow key was holded down before
                'Increment the variable
                NumOfUpArrowArray(CurrentNum) = NumOfUpArrowArray(CurrentNum) + 1
            
                'Stores the number of milliseconds that have elapsed
                'since the system was started when a user holds down
                'Up Arrow key
                StartMSecForUpArrow = GetTickCount()
            End If
            StartFlagForUpArrow = True 'Set Start Flag for Up Arrow true
        End If
    
        If wParam = 38 And lParam < 0 Then
            'Up Arrow Key is being released
            If StartFlagForUpArrow = True Then
                'Up Arrow Key has been holded down before
                'Stores the number of milliseconds that have elapsed
                'since the system was started when a user release
                'Up Arrow key
                EndMSecForUpArrow = GetTickCount()
                
                'Accumulate the time that a user spends holding down Up Arrow Key
                MSecForUpArrow = MSecForUpArrow + (EndMSecForUpArrow - StartMSecForUpArrow)
            End If
            StartFlagForUpArrow = False 'Set Start Flag for Up Arrow key false
        End If
    
        If wParam = 40 And lParam > 0 Then
            'Down Arrow Key is being holded down
            If StartFlagForDownArrow = False Then
                'No Down Arrow key was holded down before
                'Increment the variable
                NumOfDownArrowArray(CurrentNum) = NumOfDownArrowArray(CurrentNum) + 1
                
                'Stores the number of milliseconds that have elapsed
                'since the system was started when a user holds down
                'Down Arrow key
                StartMSecForDownArrow = GetTickCount()
            End If
            StartFlagForDownArrow = True 'Set Start Flag for Down Arrow Key true
        End If
    
        If wParam = 40 And lParam < 0 Then
            'Down Arrow Key is being released
            If StartFlagForDownArrow = True Then
                'Down Arrow Key has been holded down before
                'Stores the number of milliseconds that have elapsed
                'since the system was started when a user release
                'Down Arrow key
                EndMSecForDownArrow = GetTickCount()
                
                'Accumulate the time that a user spends holding down Down Arrow Key
                MSecForDownArrow = MSecForDownArrow + (EndMSecForDownArrow - StartMSecForDownArrow)
            End If
            StartFlagForDownArrow = False 'Set Start Flag for Down Arrow Key false
        End If
    
        If wParam = 33 And lParam > 0 Then
            'Page Up Key is being holded down
            If StartFlagForPageUp = False Then
                'No Page Up key was holded down before
                'Increment the variable
                NumOfPageUpArray(CurrentNum) = NumOfPageUpArray(CurrentNum) + 1
                
                'Stores the number of milliseconds that have elapsed
                'since the system was started when a user holds down
                'Page Up key
                StartMSecForPageUp = GetTickCount()
            End If
            StartFlagForPageUp = True 'Set Start Flag for Page Up Key true
        End If
    
        If wParam = 33 And lParam < 0 Then
            'Page Up Key is being released
            If StartFlagForPageUp = True Then
                'Page Up has been holded down before
                'Stores the number of milliseconds that have elapsed
                'since the system was started when a user release
                'Page Up key
                EndMSecForPageUp = GetTickCount()
                
                 'Accumulate the time that a user spends holding down Page Up Key
                 MSecForPageUp = MSecForPageUp + (EndMSecForPageUp - StartMSecForPageUp)
            End If
            StartFlagForPageUp = False 'Set Start Flag for Page Up Key false
        End If
    
        If wParam = 34 And lParam > 0 Then
            'Page Down Key is being holded down
            If StartFlagForPageDown = False Then
                'No Page Down key was holded down before
                'Increment the variable
                NumOfPageDownArray(CurrentNum) = NumOfPageDownArray(CurrentNum) + 1
                
                'Stores the number of milliseconds that have elapsed
                'since the system was started when a user holds down
                'Page Down key
                StartMSecForPageDown = GetTickCount()
            End If
            StartFlagForPageDown = True 'Set Start Flag for Page Down Key true
        End If
    
        If wParam = 34 And lParam < 0 Then
            'Page Down Key is being released
            If StartFlagForPageDown = True Then
                'Page Down Key has been holded down before
                'Stores the number of milliseconds that have elapsed
                'since the system was started when a user release
                'Page Down Key
                EndMSecForPageDown = GetTickCount()
                
                'Accumulate the time that a user spends holding down Page Down Key
                MSecForPageDown = MSecForPageDown + (EndMSecForPageDown - StartMSecForPageDown)
            End If
            StartFlagForPageDown = False 'Set Start Flag for Page Up Key false
        End If
    End If
    
    
    ' Forward to next hook
    KeyboardProc = CallNextHookEx(hHook, nCode, wParam, lParam)

End Function
